'============================================================================
'J.M.K S.F. BatchBASIC 1.1.1 CLASSIC
'(c) 2000 by Jan-Max Meyer Krapohl, owner of J.M.K S.F.
'Programming Language, Compiler and Interpreter Developments & Resources
'http://home.t-online.de/home/cochisecom/jmksf.htm
'jmk.software.factory@web.de
'============================================================================
'Dieses Programm ist freie Software. Sie koennen es unter
'den Bedingungen der GNU General Public License, wie von der
'Free Software Foundation herausgegeben, weitergeben und/oder
'modifizieren, entweder unter Version 2 der Lizenz oder (wenn
'Sie es wuenschen) jeder spaeteren Version.

'Die Veroeffentlichung dieses Programms erfolgt in der
'Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE
'GEWAEHRLEISTUNG - sogar ohne die implizite Gewaehrleistung
'der MARKTREIFE oder der EIGNUNG FUER EINEN BESTIMMTEN ZWECK.
'Details finden Sie in der GNU General Public License.

'Sie sollten eine Kopie der GNU General Public License zusammen
'mit diesem Programm erhalten haben. Falls nicht, schreiben Sie
'an die Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
'MA 2139, USA oder an jmk.software.factory@web.de !
'============================================================================
'Es wird fr keine Schaeden, die mit dieser Programmiersprache angestellt oder
'passiert werden, gehaftet.
'============================================================================
'Sie  muessen  bei  jeder von Ihnen weiterentwickelten oder kopierten Version,
'die unter Ihrem Namen laeuft, mir Copyrights und Credits (wie ganz oben)  ge-
'ben,   und   eine   Kopie   inklusive   Quellcode   via  eMail   an    J.M.K,
'jmk.software.factory@web.de , senden.
'============================================================================


'*****************
'*  CODE BEGINN  *
'*****************


COLOR 7, 0
PRINT "J.M.K S.F. BatchBASIC 1.1.1 Interpreter"
PRINT "(c) 2000 by Jan-Max Meyer Krapohl, owner of J.M.K S.F."
PRINT "Programming Language, Compiler and Interpreter Developments & Resources"
PRINT "http://home.t-online.de/home/cochisecom/jmksf.htm"
PRINT "jmk.software.factory@web.de"
COLOR 4, 0
PRINT
SLEEP 1
COLOR 7, 0
ON ERROR GOTO error1
filename$ = LTRIM$(RTRIM$(COMMAND$))
stringvar$ = ""
OPEN filename$ FOR INPUT AS #1
CLS
DO
INPUT #1, bbcode$
bbcode2$ = UCASE$(bbcode$)
IF LEFT$(bbcode2$, 3) = "PRI" THEN GOTO printbe
IF LEFT$(bbcode2$, 3) = "LPR" THEN GOTO lprintbe
IF LEFT$(bbcode2$, 3) = "PAU" THEN GOTO pausebe
IF LEFT$(bbcode2$, 3) = "WAI" THEN GOTO waitbe
IF LEFT$(bbcode2$, 3) = "SHE" THEN GOTO shellbe
IF LEFT$(bbcode2$, 3) = "INP" THEN GOTO inputbe
IF LEFT$(bbcode2$, 3) = "CLS" THEN GOTO clearbe
IF LEFT$(bbcode2$, 3) = "BAT" THEN GOTO batch
IF LEFT$(bbcode2$, 4) = "BEEP" THEN BEEP
IF LEFT$(bbcode2$, 4) = "BEEP" THEN GOTO nextzeile

IF LEFT$(bbcode2$, 3) = "END" THEN GOTO nextzeile
IF LEFT$(bbcode2$, 1) = "'" THEN GOTO nextzeile
IF RIGHT$(bbcode2$, 1) = ":" THEN GOTO nextzeile
GOTO nextzeile

'=====================BEGIN DES PROGRAMMIERSPRACHEN-FUNKTIONSBLOCKS===========
printbe:
'Schreibe etwas auf Bildschirm.
'Beispiel: PRINT Hallo !
text$ = MID$(bbcode$, 7)

'Wenn text$ ist gleich "string$" dann schreibe Inhalt der Variable stringvar$
'sonst schreibe vorhandenen Text.

IF text$ = "string$" THEN PRINT stringvar$ ELSE PRINT text$
GOTO nextzeile

'-------------------------------------------------------------------------

lprintbe:
'Drucke Text auf dem Drucker LPT-1 aus.
'Beispiel: LPRINT Hallo !
text$ = MID$(bbcode$, 8)

'Wenn text$ ist gleich "string$" dann drucke Inhalt der Variable stringvar$
'sonst drucke vorhandenen Text.

IF text$ = "string$" THEN LPRINT stringvar$ ELSE LPRINT text$
GOTO nextzeile

'-------------------------------------------------------------------------

pausebe:
'Warte bis Benutzer eine Taste drckt.
'Beispiel: PAUSE
PRINT "Weiter mit beliebiger Taste..."
DO
LOOP WHILE INKEY$ = ""
GOTO nextzeile

'-------------------------------------------------------------------------

waitbe:

'Warte eine bestimmten anzahl von Sekunden ab
'Beispiel: WAIT=1

'Lese ekundenanzahl aus den Code:
laenge$ = MID$(bbcode$, 6)
'Forme laenge$ in laenge% um:
laenge% = VAL(laenge$)

'Ausfhren
SLEEP laenge%
GOTO nextzeile

'-------------------------------------------------------------------------

shellbe:
'Befehl an der MS-DOS Shell ausfhren.
'Beispiel: SHELL dir *.exe

makeonshell$ = MID$(bbcode$, 7)

'Wenn dor string1$ steht, dann fhre an der MS-DOS Shell die Variable
'stringvar$ aus, sonst den dort stehenden Text.

IF makeonshell$ = "string$" THEN SHELL stringvar$ ELSE SHELL makeonshell$
GOTO nextzeile

'-------------------------------------------------------------------------

inputbe:
'Eingabe von Text in die Variable stringvar$.
'Beispiel: INPUT Bitte was eingeben:
text2$ = MID$(bbcode$, 7)
PRINT text2$;
INPUT "", stringvar$
GOTO nextzeile

'-------------------------------------------------------------------------

clearbe:
'Lschen des Bildschirms. Beispiel: CLS
CLS
GOTO nextzeile

'-------------------------------------------------------------------------


batch:
'Erlaubt die einbindung von Batchprogrammen in BatchBASIC-Programme
'Beispiel:  BATCH=START
'           @echo off
'           echo Hallo Welt !
'           pause
'           BATCH=END
OPEN "temp.bat" FOR APPEND AS #3
andnext:
INPUT #1, bbcode$
bbcode2$ = UCASE$(bbcode$)
IF LEFT$(bbcode2$, 9) = "BATCH=END" THEN GOTO weiter
PRINT #3, bbcode$
GOTO andnext
weiter:
CLOSE #3
'Starten des Batchprogramms
SHELL "temp"
'Und, da wir das Batchprogramm nicht mehr brauchen...
SHELL "del temp.bat"
GOTO nextzeile

'==============================ENDE FUNKTIONEN-BLOCK=========================

nextzeile:
LOOP UNTIL bbcode2$ = "END"
CLOSE #1

COLOR 7, 0
END

error1:
COLOR 4, 0
PRINT "Datei erforderlich !"
COLOR 7, 0
PRINT
PRINT "Bitte benutzen Sie"
COLOR 14, 0
PRINT "bb dateiname.bbf"
COLOR 7, 0
PRINT
PRINT "J.M.K S.F. BatchBASIC kehrt zu MS-DOS zurck..."
SLEEP 4
CLS
END



